----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:02:12 10/16/2008 
-- Design Name: 
-- Module Name:    VME_top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use mylib.DCC_pack.all;
use mylib.chipsize.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity VME_top is
		generic (sim : boolean := false);
    Port ( clkin : in  STD_LOGIC;
           RXCLK_p : in  STD_LOGIC;
           RXCLK_n : in  STD_LOGIC;
           RXD_p : in  STD_LOGIC_VECTOR (4 downto 0);
           RXD_n : in  STD_LOGIC_VECTOR (4 downto 0);
           TXCLK_p : out  STD_LOGIC;
           TXCLK_n : out  STD_LOGIC;
           TXD_p : out  STD_LOGIC_VECTOR (4 downto 0);
           TXD_n : out  STD_LOGIC_VECTOR (4 downto 0);
-- SWITCHES
           SN : in std_logic_vector(7 downto 0);
           SW_BAR : in std_logic_vector(4 downto 0);
           SW_use : in std_logic;
           auto_ID : in std_logic;
           spare : in std_logic;
-- VME bus signals
--					 RESETn : in std_logic;
           VAM : in  STD_LOGIC_VECTOR (5 downto 0);
					 VWRITEn : in std_logic;
           VDSn : in  STD_LOGIC_VECTOR (1 downto 0);
					 VASn : in std_logic;
           GAn : in  STD_LOGIC_VECTOR (4 downto 0);
					 GAnP : in std_logic;
					 VIACKn : in std_logic;
					 VIACKINn : in std_logic;
					 T_DTACK : out std_logic;
					 VDTACKn : out std_logic;
					 VBERRn : out std_logic;
					 VOEn : out std_logic;
					 D_DIR : out std_logic;
					 A_DIR : out std_logic;
					 VSYSFAILn : out std_logic;
					 VIACKOUTn : out std_logic;
					 VIRQ1n : out std_logic;
					 VIRQ2n : out std_logic;
					 VIRQ4n : out std_logic;
					 VIRQ7n : out std_logic;
           VA : inout  STD_LOGIC_VECTOR (31 downto 0);
           VD : inout  STD_LOGIC_VECTOR (31 downto 0);
-- SIFALSH interface
					 M_Q : in std_logic;
					 M_C : out std_logic;
					 M_S : out std_logic;
					 M_D : out std_logic;
					 reconf_n : out std_logic; -- this pin is dual-purpose pin INIT_B
           M : in  STD_LOGIC_VECTOR (2 downto 0);
           VS : in  STD_LOGIC_VECTOR (2 downto 0);
           CTRL : out  STD_LOGIC_VECTOR (4 downto 0)
					 );
end VME_top;

architecture Behavioral of VME_top is
constant t_rst_crc : std_logic_vector(23 downto 0) := x"020028";
constant t_crc_dcc : std_logic_vector(23 downto 0) := x"7F14C9";
signal t_crc_end : std_logic_vector(23 downto 0);
signal cntr_msb : positive;
signal RXCLK_in : std_logic := '0';
signal RXCLK_buf : std_logic := '0';
signal RXCLK : std_logic := '0';
signal RXCLKn : std_logic := '0';
signal rst_RXCLK : std_logic := '0';
signal RXCLK90 : std_logic := '0';
--signal RXCLK270 : std_logic := '0';
--signal rst_dcm : std_logic := '0';
signal RXCLK_dcm : std_logic := '0';
signal RXCLKn_dcm : std_logic := '0';
signal RXCLK90_dcm : std_logic := '0';
signal locked : std_logic_vector(1 downto 0) := (others => '0');
signal RXclk_q : std_logic := '0';
signal RXclk_sync : std_logic_vector(1 downto 0) := (others => '0');
signal RXclk_cntr : std_logic_vector(1 downto 0) := (others => '0');
--signal psincdec : std_logic := '0';
--signal ps_rdy : std_logic := '0';
--signal psen : std_logic := '0';
--signal psdone : std_logic := '0';
--signal err_cntr : std_logic_vector(7 downto 0) := (others => '0');
--signal ps_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal RXD : std_logic_vector(4 downto 0) := (others => '0');
signal TXclk : std_logic := '0';
signal TXD : std_logic_vector(4 downto 0) := (others => '0');
signal more_rd : std_logic := '0';
signal we_txbuf : std_logic := '0';
signal send_SN : std_logic := '0';
signal rst_txd : std_logic := '0';
signal txbuf_di : std_logic_vector(35 downto 0) := (others => '0');
signal txbuf_wa : std_logic_vector(8 downto 0) := (others => '0');
signal txbuf_ra : std_logic_vector(10 downto 0) := (others => '0');
signal rx_data : std_logic_vector(9 downto 0) := (others => '0');
signal rxbuf_do : std_logic_vector(31 downto 0) := (others => '0');
signal rxbuf_wa : std_logic_vector(10 downto 0) := (others => '0');
signal rst_rxbuf : std_logic := '0';
--signal rst_rxbuf : std_logic_vector(3 downto 0) := (others => '0');
signal rxbuf_wa_sync : std_logic_vector(3 downto 0) := (others => '0');
signal rxbuf_wa_sync2 : std_logic_vector(3 downto 0) := (others => '0');
signal rxbuf_ra : std_logic_vector(8 downto 0) := (others => '0');
signal tx_data : std_logic_vector(9 downto 0) := (others => '0');
--signal clk2x_dcm : std_logic := '0';
signal clk0 : std_logic := '0';
signal clk0_dcm : std_logic := '0';
signal clk90 : std_logic := '0';
signal clk90_dcm : std_logic := '0';
signal clk180 : std_logic := '0';
signal clk180_dcm : std_logic := '0';
signal clk270 : std_logic := '0';
signal clk270_dcm : std_logic := '0';
signal reset : std_logic := '0';
signal strobe : std_logic := '0';
signal A32_mode : std_logic := '0';
signal clkdv2 : std_logic := '0';
signal key_OK : std_logic := '0';
signal cpld_str : std_logic := '0';
signal stop_M_C : std_logic := '0';
signal en_M_C : std_logic := '0';
signal FAST_READ : std_logic := '0';
signal rom_FAST_READ : std_logic := '0';
signal flash_MD : std_logic := '0';
signal flash_MCS : std_logic_vector(1 downto 0) := (others => '0');
signal flash_busy : std_logic := '0';
signal reg_data : std_logic_vector(31 downto 0) := (others => '0');
signal flash_wdata : std_logic_vector(31 downto 0) := (others => '0');
signal flash_rdata : std_logic_vector(31 downto 0) := (others => '0');
signal sel_mod : std_logic := '0';
signal sel_mod_q : std_logic := '0';
signal sel_mod_dl : std_logic := '0';
signal inc_addr : std_logic := '0';
signal CRC_vme : std_logic_vector(24 downto 0) := (others => '0');
signal CRC_DCC : std_logic_vector(23 downto 0) := (others => '0');
signal CRC_LRB : std_logic_vector(23 downto 0) := (others => '0');
signal VME_csr : std_logic_vector(31 downto 0) := (others => '0');
signal w_A32_cycle : std_logic := '0';
signal w_A32_ack : std_logic := '0';
signal last_word : std_logic := '0';
signal we_rfifo : std_logic := '0';
signal rfifo_afull : std_logic := '0';
signal vme_read : std_logic := '0';
signal vme_am : std_logic_vector(5 downto 0) := (others => '0');
signal w_data : std_logic_vector(31 downto 0) := (others => '0');
signal r_data : std_logic_vector(31 downto 0) := (others => '0');
signal we_byte : std_logic_vector(3 downto 0) := (others => '0');
signal addr : std_logic_vector(15 downto 0) := (others => '0');
signal reconf : std_logic := '0';
signal reconf_q : std_logic := '0';
signal CONF_busy : std_logic := '0';
signal CONF_busy_q : std_logic := '0';
signal M_S_i : std_logic := '0';
signal reprog : std_logic := '0';
signal rst_reprog : std_logic := '0';
signal rst_crc : std_logic := '0';
signal calc_crc : std_logic := '0';
signal calc_crc_q : std_logic := '0';
signal ld_CRC_dcc : std_logic := '0';
signal conf_cntr : std_logic_vector(23 downto 0) := (others => '0');
signal cpld_data : std_logic_vector(24 downto 0) := (others => '0');
signal CTRL_i : std_logic_vector(4 downto 0) := (others => '0');
signal mem_test : std_logic := '0';
signal mem_test_q : std_logic := '0';
signal rx_data8_q : std_logic := '0';
signal ec_lfsr : std_logic := '0';
signal mem_test_cntr : std_logic_vector(1 downto 0) := (others => '0');
signal lfsr : std_logic_vector(31 downto 0) := (others => '0');
signal ec_lfsr2 : std_logic := '0';
signal lfsr2 : std_logic_vector(31 downto 0) := (others => '0');
signal mem_err : std_logic := '0';
signal err_cntr : std_logic_vector(31 downto 0) := (others => '0');
signal loc_cntr : std_logic_vector(31 downto 0) := (others => '0');
signal lfsr_reg : std_logic_vector(31 downto 0) := (others => '0');
signal rxbuf_reg : std_logic_vector(31 downto 0) := (others => '0');
--signal cpld_wc : std_logic_vector(5 downto 0) := (others => '0');
--attribute IOB: string;
--attribute IOB of RXclk_q : signal is "true";
attribute LOC : string;
--attribute LOC of i_clk : label is "BUFGMUX_x1y0"; -- global D
attribute LOC of i_clk0 : label is "BUFGMUX_x2y1"; -- global A
attribute LOC of i_clk90 : label is "BUFGMUX_x1y0"; -- global A
attribute LOC of i_clk180 : label is "BUFGMUX_x2y0"; -- global B
attribute LOC of i_clk270 : label is "BUFGMUX_x1y1"; -- global A
--attribute LOC of i_RXclk : label is "BUFGMUX_x1y11"; -- global G
--attribute LOC of i_RXclkn : label is "BUFGMUX_x1y10"; -- global H
--attribute LOC of i_RXclk90 : label is "BUFGMUX_x2y11"; -- global E
attribute LOC of i_RXclk_buf : label is "BUFGMUX_x0y6"; -- left E
attribute LOC of i_DCM_TXCLK : label is "DCM_x0y0"; -- bottom left
--attribute LOC of i_DCM_RXCLK : label is "DCM_x0y1"; -- top left
--attribute LOC of RXclk_sync : signal is "slice_x0y30:slice_x1y31";
attribute INIT: string;
attribute INIT of CTRL_i : signal is "S";
begin
cntr_msb <= 14 when sim else 23;
--t_crc_end <=  x"004889" when sim else x"944089";
t_crc_end <=  x"004889" when sim else eof;
reconf_n <= not reconf;
--i_rst_dcm : SRL16 generic map(INIT => x"ffff")
--   port map (
--      Q => rst_dcm,       -- SRL data output
--      A0 => '1',     -- Select[0] input
--      A1 => '1',     -- Select[1] input
--      A2 => '1',     -- Select[2] input
--      A3 => '1',     -- Select[3] input
--      CLK => clkin,   -- Clock input
--      D => '0'        -- SRL data input
--   );
i_DCM_TXCLK: DCM_SP 
   generic map(CLKIN_PERIOD => 10.0,DESKEW_ADJUST => "SOURCE_SYNCHRONOUS",STARTUP_WAIT => true)  
	 port map	
         ( CLKIN   => clkin ,
           CLKFB   => clk0 ,
           RST     => '0',
           DSSEN   => '0' ,
           PSINCDEC=> '0',
           PSEN    => '0',
           PSCLK   => '0',
					 clk0    => clk0_dcm,
					 clk90    => clk90_dcm,
           CLK180   => clk180_dcm,
					 clk270    => clk270_dcm,
					 LOCKED	 => locked(0));
i_clk0: bufg port map(i => clk0_dcm, o => clk0);
i_clk90: bufg port map(i => clk90_dcm, o => clk90);
i_clk180: bufg port map(i => clk180_dcm, o => clk180);
i_clk270: bufg port map(i => clk270_dcm, o => clk270);
i_RXclkds: ibufgds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => RXCLK_p, ib => RXCLK_n, o => RXclk_in);
i_RXclk_buf: bufg port map(i => RXclk_in, o => RXclk);
RXclkn <= not RXclk;
--process(RXclk90)
--begin
--	if(RXclk90'event and RXclk90 = '1')then
--		RXclk_cntr(1) <= RXclk_cntr(1) xor RXclk_cntr(0);
--		RXclk_cntr(0) <= not RXclk_cntr(0);
--		if(RXclk_cntr = "11")then
--			rxclk_q <= rxclk_in;
--		end if;
--	end if;
--end process;
--rst_rxclk <= M(1);
--i_DCM_RXCLK: DCM_SP 
--   generic map(CLKOUT_PHASE_SHIFT => "VARIABLE",CLKIN_PERIOD => 6.66,
--					PHASE_SHIFT => 0,DESKEW_ADJUST => "SOURCE_SYNCHRONOUS")  
--	 port map	
--         ( CLKIN   => RXclk_buf ,
--           CLKFB   => RXclk ,
--           RST     => rst_rxclk, -- this is from U0 done and all-lock
--           DSSEN   => '0' ,
--           PSINCDEC=> psincdec ,
--           PSEN    => psen ,
--           PSCLK   => clk ,
--					 clk0    => RXclk_dcm,
--           CLK90   => RXclk90_dcm,
--					 clk180    => RXclkn_dcm,
--					 PSDONE  => psdone,
--					 LOCKED	 => locked(1));
--i_RXclk: bufg port map(i => RXclk_dcm, o => RXclk);
--i_RXclk90: bufg port map(i => RXclk90_dcm, o => RXclk90);
--i_RXclkn: bufg port map(i => RXclkn_dcm, o => RXclkn);
--process(clk,locked)
--begin
--  if(locked(1) = '0')then
--    RXclk_sync <= "00";
--    err_cntr <= x"80";
--    ps_rdy <= '1';
--    ps_cntr <= x"80";
--		psen <= '0';
--  elsif(clk'event and clk = '1')then
--    RXclk_sync <= RXclk_sync(0) & RXclk_q;
--		if(ps_rdy = '0')then
--			err_cntr <= x"80";
--		elsif(RXclk_sync(1) = '1')then
--			err_cntr <= err_cntr + 1;
--		else
--			err_cntr <= err_cntr - 1;
--		end if;
--		if(psen = '1')then
--			psen <= '0';
--		elsif(err_cntr(7 downto 6) = "11" or err_cntr(7 downto 6) = "00")then
--			psen <= '1';
--		end if;
--		if(psdone = '1')then
--			ps_rdy <= '1';
--		elsif(err_cntr(7 downto 6) = "11" or err_cntr(7 downto 6) = "00")then
--			ps_rdy <= '0';
--		end if;
--		if(psen = '1')then
--			if(psincdec = '1')then
--				ps_cntr <= ps_cntr + 1;
--			else
--				ps_cntr <= ps_cntr - 1;
--			end if;
--		end if;
--  end if;
--end process;
--psincdec <= err_cntr(7);
g_RXD: for i in 0 to 4 generate
	i_RXDbuf: ibufds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33",IFD_DELAY_VALUE => "0") port map(i => RXD_p(i), ib => RXD_n(i), o => RXD(i));
   i_RXddr : IDDR2
   generic map(DDR_ALIGNMENT => "C0")
   port map (
      Q0 => rx_data(2*i), -- 1-bit output captured with C0 clock
      Q1 => rx_data(2*i+1), -- 1-bit output captured with C1 clock
      C0 => RXclk, -- 1-bit clock input
      C1 => RXclkn, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D => RXD(i),   -- 1-bit data input 
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
end generate;
i_rxbuf : RAMB16BWE_S36_S9
   port map (
      DOA => rxbuf_do,      -- Port A 32-bit Data Output
--      DOPA => rxbuf_do(35 downto 32),    -- Port A 4-bit Parity Output
      ADDRA => rxbuf_ra,  -- Port A 9-bit Address Input
      ADDRB => rxbuf_wa,  -- Port B 11-bit Address Input
      CLKA => clk0,    -- Port A 1-bit Clock
      CLKB => RXclk,    -- Port B 1-bit Clock
      DIA => x"00000000",      -- Port A 32-bit Data Input
      DIB => rx_data(7 downto 0),      -- Port B 8-bit Data Input
      DIPA => x"0",    -- Port A 4-bit parity Input
      DIPB => "0",    -- Port B 1-bit parity Input
      ENA => '1',      -- Port A 1-bit RAM Enable Input
      ENB => rx_data(9),      -- Port B 1-bit RAM Enable Input
      SSRA => '0',    -- Port A 1-bit Synchronous Set/Reset Input
      SSRB => '0',    -- Port B 1-bit Synchronous Set/Reset Input
      WEA => x"0",      -- Port A 4-bit Write Enable Input
      WEB => '1'       -- Port B 1-bit Write Enable Input
   );
process(RXclk,rst_rxbuf)
begin
	if(rst_rxbuf = '1')then
		rxbuf_wa <= (others => '0');
	elsif(RXclk'event and RXclk = '1')then
		if(rx_data(9) = '1')then
			rxbuf_wa(1) <= rxbuf_wa(1) xor rxbuf_wa(0);
			rxbuf_wa(0) <= not rxbuf_wa(0);
			if(rxbuf_wa(1 downto 0) = "11")then
				rxbuf_wa(2) <= not rxbuf_wa(5) xor rxbuf_wa(4) xor rxbuf_wa(3);
				if(rxbuf_wa(2) = '1')then
					rxbuf_wa(3) <= not rxbuf_wa(5) xor rxbuf_wa(4);
				end if;
				if(rxbuf_wa(3 downto 2) = "10")then
					rxbuf_wa(4) <= not rxbuf_wa(5);
				end if;
				if(rxbuf_wa(3 downto 2) = "00")then
					rxbuf_wa(5) <= rxbuf_wa(4);
				end if;
			end if;
		end if;
	end if;
end process;
process(clk0, rx_data)
begin
	if(rx_data(8) = '1' and rx_data8_q = '0')then
		rst_rxbuf <= '0';
	elsif(clk0'event and clk0 = '1')then
		if(sel_mod = '0' and mem_test = '0')then
			rst_rxbuf <= '1';
		end if;
	end if;
end process;
process(clk0)
begin
	if(clk0'event and clk0 = '1')then
--		if(sel_mod_q = '0' and mem_test = '0')then
--			rst_rxbuf <= x"8";
--		elsif(rst_rxbuf(3) = '1')then
--			rst_rxbuf <= rst_rxbuf + 1;
--		end if;
		rx_data8_q <= rx_data(8);
		if(rst_rxbuf = '1')then
			rxbuf_ra <= (others => '0');
		elsif((mem_test = '0' and inc_addr = '1') or ec_lfsr2 = '1')then
			rxbuf_ra(0) <= not rxbuf_ra(3) xor rxbuf_ra(2) xor rxbuf_ra(1);
			if(rxbuf_ra(0) = '1')then
				rxbuf_ra(1) <= not rxbuf_ra(3) xor rxbuf_ra(2);
			end if;
			if(rxbuf_ra(1 downto 0) = "10")then
				rxbuf_ra(2) <= not rxbuf_ra(3);
			end if;
			if(rxbuf_ra(1 downto 0) = "00")then
				rxbuf_ra(3) <= rxbuf_ra(2);
			end if;
		end if;
		rxbuf_wa_sync <= rxbuf_wa(5 downto 2);
		rxbuf_wa_sync2 <= rxbuf_wa_sync;
		if(rfifo_afull = '1' or sel_mod = '0' or inc_addr = '1')then
			inc_addr <= '0';
		elsif((vme_read = '1' and vme_am(5) = '1') or (rxbuf_wa_sync2 /= rxbuf_ra(3 downto 0) and mem_test = '0'))then
			inc_addr <= '1';
		else
			inc_addr <= '0';
		end if;
		we_rfifo <= inc_addr and vme_read;
	end if;
end process;
i_TXclkbuf : OBUFDS generic map(IOSTANDARD => "LVDS_33") port map (O => TXclk_p, OB => TXclk_n, I => TXclk);
i_TXclkddr : ODDR2
		port map (
      Q => TXclk, -- 1-bit output data
      C0 => clk90, -- 1-bit clock input
      C1 => clk270, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => '1',   -- 1-bit data input (associated with C0)
      D1 => '0',   -- 1-bit data input (associated with C1)
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
g_TXD: for i in TXD'range generate
	i_TXDbuf : OBUFDS generic map(IOSTANDARD => "LVDS_33") port map (O => TXD_p(i), OB => TXD_n(i), I => TXD(i));
	i_TXDddr : ODDR2
		generic map(DDR_ALIGNMENT => "C0")
		port map (
      Q => TXD(i), -- 1-bit output data
      C0 => clk0, -- 1-bit clock input
      C1 => clk180, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => tx_data(5+i),   -- 1-bit data input (associated with C0) tx_data(9 downto 5) goes out first
      D1 => tx_data(i),   -- 1-bit data input (associated with C1) tx_data(4 downto 0) goes out second
      R => rst_txd,    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
end generate;
i_txbuf : RAMB16BWE_S36_S9
   port map (
      DOB => tx_data(7 downto 0),      -- Port B 8-bit Data Output
      DOPB => tx_data(8 downto 8),    -- Port B 1-bit Parity Output
      ADDRA => txbuf_wa,  -- Port A 9-bit Address Input
      ADDRB => txbuf_ra,  -- Port B 11-bit Address Input
      CLKA => clk0,    -- Port A 1-bit Clock
      CLKB => clk0,    -- Port B 1-bit Clock
      DIA => txbuf_di(31 downto 0),      -- Port A 32-bit Data Input
      DIB => x"00",      -- Port B 8-bit Data Input
      DIPA => txbuf_di(35 downto 32),    -- Port A 4-bit parity Input
      DIPB => "0",    -- Port B 1-bit parity Input
      ENA => we_txbuf,      -- Port A 1-bit RAM Enable Input
      ENB => '1',      -- Port B 1-bit RAM Enable Input
      SSRA => '0',    -- Port A 1-bit Synchronous Set/Reset Input
      SSRB => '0',    -- Port B 1-bit Synchronous Set/Reset Input
      WEA => x"f",      -- Port A 4-bit Write Enable Input
      WEB => '0'       -- Port B 1-bit Write Enable Input
   );
txbuf_wa(8 downto 3) <= "000000";
txbuf_ra(10 downto 5) <= "000000";
process(sel_mod_q,vme_am)
begin
	if(sel_mod_q = '0')then
		A32_mode <= not vme_am(5) and not mem_test;
	end if;
end process;
process(clk0)
begin
	if(clk0'event and clk0 = '1')then
		sel_mod_q <= sel_mod;
		mem_test_q <= mem_test;
		if(send_SN = '1' or ec_lfsr = '1' or mem_test /= mem_test_q or (A32_mode = '1' and ((sel_mod_q /= sel_mod or we_byte /= x"0") or 
				(more_rd = '1' and rfifo_afull = '0' and addr(3 downto 0) = x"0" and we_txbuf = '0'))))then
			we_txbuf <= '1';
		else
			we_txbuf <= '0';
		end if;
		if(mem_test = '1' and mem_err = '0')then
			mem_test_cntr <= mem_test_cntr + 1;
		else
			mem_test_cntr <= "00";
		end if;
		if(mem_test_cntr = "11")then
			ec_lfsr <= '1';
		else
			ec_lfsr <= '0';
		end if;
		if(sel_mod = '0' or vme_am(5) = '1' or vme_am(1) = '0' or vme_am(0) /= vme_am(1) or vme_read = '0')then
			more_rd <= '0';
		else
			more_rd <= not we_txbuf and (more_rd or we_rfifo);
		end if;
		if(ec_lfsr = '1')then
			txbuf_di(35 downto 32) <= x"f";
		else
			txbuf_di(35 downto 32) <= we_byte;		
		end if;
		if(ec_lfsr = '1')then
			txbuf_di(31 downto 0) <= lfsr;
		elsif(we_byte = x"0")then
			txbuf_di(31 downto 0) <= mem_test & SN(7 downto 1) & vme_read & sel_mod & vme_am(5) & SN(0) & vme_am(3 downto 0) & addr;
		else
			txbuf_di(31 downto 0) <= w_data;
		end if;
	end if;
end process;
process(clk180)
begin
	if(clk180'event and clk180 = '1')then
		rst_txd <= not tx_data(9);
	end if;
end process;
process(clk0)
begin
	if(clk0'event and clk0 = '1')then
		if(we_txbuf = '1')then
			txbuf_wa(2 downto 0) <= txbuf_wa(2 downto 0) + 1;
		end if;
		if(txbuf_ra(4 downto 2) = txbuf_wa(2 downto 0))then
			tx_data(9) <= '0';
		else
			tx_data(9) <= '1';
			txbuf_ra(4 downto 0) <= txbuf_ra(4 downto 0) + 1;
		end if;
		if(sel_mod_q = '0' or vme_am(1 downto 0) /= "00")then
			last_word <= '1';
		elsif(addr(14) = '1')then
			last_word <= last_word xor inc_addr;
		elsif(txbuf_ra(1 downto 0) = "01")then
			last_word <= not last_word;
		end if;
		if(sel_mod_q = '0' or mem_test = '1')then
			w_A32_cycle <= '0';
		elsif(vme_read = '0' and txbuf_ra(1 downto 0) = "01")then
			w_A32_cycle <= '1';
		end if;
		if(w_A32_cycle = '0')then
			w_A32_ack <= '0';
		elsif(addr(14) = '1' and last_word = '1')then
			w_A32_ack <= inc_addr;
		elsif(txbuf_ra(1 downto 0) = "01" and last_word = '1')then
			w_A32_ack <= '1';
		else
			w_A32_ack <= '0';
		end if;
	end if;
end process;
process(clk0)
begin
	if(clk0'event and clk0 = '1')then
    if(mem_test = '0')then
	   lfsr <= (others => '0');
		elsif(ec_lfsr = '1')then
	   lfsr <= lfsr(30 downto 0) & not(lfsr(31) xor lfsr(21) xor lfsr(1) xor lfsr(0));
		end if;
    if(mem_test = '0')then
	   lfsr2 <= (others => '0');
		elsif(ec_lfsr2 = '1')then
	   lfsr2 <= lfsr2(30 downto 0) & not(lfsr2(31) xor lfsr2(21) xor lfsr2(1) xor lfsr2(0));
		end if;
		if(mem_test = '0' or ec_lfsr2 = '1')then
			ec_lfsr2 <= '0';
		elsif(rxbuf_wa_sync2 /= rxbuf_ra(3 downto 0))then
			ec_lfsr2 <= '1';
		else
			ec_lfsr2 <= '0';
		end if;
		if(mem_test = '0')then
			mem_err <= '0';
		elsif(ec_lfsr2 = '1' and lfsr2 /= rxbuf_do)then
			mem_err <= '1';
		end if;
		if(mem_test = '0')then
			loc_cntr <= (others => '0');
			lfsr_reg <= (others => '0');
			rxbuf_reg <= (others => '0');
		elsif(mem_err = '0')then
			if(ec_lfsr2 = '1')then
				loc_cntr <= loc_cntr + 1;
			end if;
			lfsr_reg <= lfsr2;
			rxbuf_reg <= rxbuf_do;
		end if;
		if(mem_test = '0')then
			err_cntr <= (others => '0');
		elsif(ec_lfsr2 = '1' and err_cntr(31) = '0' and lfsr2 /= rxbuf_do)then
			err_cntr <= err_cntr + 1;
		end if;
	end if;
end process;
process(clk0,locked)
begin
	if(locked(0) = '0')then
		key_OK <= '0';
	elsif(clk0'event and clk0 = '1')then
		if(w_data = key and vme_am(5) = '1' and we_byte = x"f" and addr(9 downto 0) = key_addr(11 downto 2))then
			key_OK <= '1';
		elsif(we_byte /= x"0")then
			key_OK <= '0';
		end if;
	end if;
end process;
i_vme_if: vme_if generic map(swap_byte => swap_byte,swap_lw => swap_lw) PORT MAP(
		AM => VAM,
		WRITEn => VWRITEn,
		DSn => VDSn,
		ASn => VASn,
		GAn => GAn,
		GAnP => GAnP,
		IACKn => VIACKn,
		IACKINn => VIACKINn,
		T_DTACK => T_DTACK,
		DTACKn => VDTACKn,
		BERRn => VBERRn,
		D_DIR => D_DIR,
		A_DIR => A_DIR,
		OEn => VOEn,
		SYSFAILn => VSYSFAILn,
		IACKOUTn => VIACKOUTn,
		IRQ1n => VIRQ1n,
		IRQ2n => VIRQ2n,
		IRQ4n => VIRQ4n,
		IRQ7n => VIRQ7n,
		A => VA,
		D => VD,
		SW_BAR => SW_BAR,
		SW_use => SW_use,
		clk => clk0,
		inc_addr => inc_addr,
		w_A32_ack => w_A32_ack,
		we_rfifo => we_rfifo,
		rfifo_afull => rfifo_afull,
		vme_am => vme_am,
		vme_read => vme_read,
		sel_mod => sel_mod,
		r_data => r_data,
		w_data => w_data,
		we_byte => we_byte,
		addr => addr
	);
i_flash: flash generic map(swap_byte => swap_byte) PORT MAP(
		clk => clk0,
		vme_am => vme_am,
		addr => addr,
		we_byte => we_byte,
		w_data => w_data,
		flash_wdata => flash_wdata,
		flash_rdata => flash_rdata,
		flash_busy => flash_busy,
		CPLD_str => cpld_str,
		MQ => M_Q,
		MD => flash_MD,
		MCS => flash_MCS
	);
process(clk0)
begin
	if(clk0'event and clk0 = '1')then
		case addr(3 downto 0) is
			when x"0" => reg_data <= VME_version & device_ID;
			when x"1" => reg_data <= x"00" & CRC_vme(23 downto 0);
			when x"2" => reg_data <= x"00" & CRC_DCC;
			when x"3" => reg_data <= x"00" & CRC_LRB;
			when x"4" => reg_data <= VME_csr;
			when x"5" => reg_data <= "0000000" & CPLD_data;
			when x"6" => reg_data <= err_cntr;
			when x"7" => reg_data <= loc_cntr;
			when x"8" => reg_data <= lfsr_reg;
			when x"9" => reg_data <= rxbuf_reg;
			when x"a" => reg_data <= x"000000" & spare & auto_ID & SW_use & SW_BAR;
			when others => reg_data <= (others => '0');
		end case;
	end if;
end process;
VME_csr <= x"20" & SN & CONF_busy & x"000" & mem_test & key_OK & FLASH_busy;
r_data <= rxbuf_do when vme_am(5) = '0' else
					reg_data when addr(9) = '0' else
					flash_rdata when addr(7) = '1' else
					flash_wdata;
-- CTRL(4) = '0' shifts crc register data out at M(2)
-- The first time after configuration it shifts out 24 bits of configuration data CRC.
-- After that 16 bits of status will be sent
-- CTRL(3) sends VME activity to DSP chip 
-- INIT_B(6) is used to initiate VME FPGA reconfigure, CTRL(0) = '1' selects starting address as 0x0, while CTRL(0) = '0'
-- selects starting address as byte address 0x40000
-- CTRL(2) = '1' reprograms U0 thru U5
-- CTRL(1) = '0' enables CCLK and CDATA for U1 thru U5 
-- CTRL(0) = '0' enables CCLK and CDATA for U0 
-- M(2) -> CPLD data input;
CTRL <= CTRL_i;
i_stop_M_C: delayN generic map(N => 3) port map(d => cpld_data(24), ce => cpld_str, c => clk0, q => stop_M_C);
process(clk0,locked)
begin
	if(locked(0) = '0')then
		strobe <= '0';
		clkdv2 <= '0';
		M_S_i <= '1';
		M_S <= '1';
		M_C <= '1';
		en_M_C <= '0';
		sel_mod_dl <= '0';
		CTRL_i <= "11111";
		CONF_busy <= '1';
		CONF_busy_q <= '1';
		CRC_vme <= (others => '0');
		reconf <= '0';
		reconf_q <= '0';
	elsif(clk0'event and clk0 = '1')then
		strobe <= not strobe;
		if(rst_reprog = '1' and reconf = '0')then
			CTRL_i(2) <= '0';
		elsif(we_byte(3) = '1' and key_OK = '1' and vme_am(5) = '1' and addr(9 downto 0) = VME_csr_addr(11 downto 2))then
			CTRL_i(2) <= w_data(0);
		end if;
		if(key_OK = '1' and vme_am(5) = '1' and we_byte(3) = '1' and addr(9 downto 0) = VME_csr_addr(11 downto 2))then
			reconf <= w_data(1);
			mem_test <= w_data(2);
		end if;
		if(strobe = '1')then
			CTRL_i(3) <= sel_mod;
			clkdv2 <= not clkdv2;
			if(clkdv2 = '1')then
				reconf_q <= reconf;
			end if;
			if(CTRL_i(2) = '1')then
				M_S_i <= '1';
			elsif(conf_cntr(cntr_msb) = '0' and conf_cntr(cntr_msb-6) = '1')then
				M_S_i <= '0';
			elsif(CONF_busy = '0')then
				M_S_i <= not flash_MCS(1) and not flash_MCS(0);
			end if;
			M_S <= M_S_i;
			M_C <= not clkdv2 or (not en_M_C and not flash_MCS(1) and not(reconf and not reconf_q));
			if(CRC_VME(24) = '0')then
				en_M_C <= '1';
			elsif(CTRL_i(2) = '1')then
				en_M_C <= '0';
			elsif((CONF_busy = '1' and M_S_i = '0') or (CONF_busy = '0' and cpld_data(24) = '0'))then
				en_M_C <= '1';
			elsif(stop_M_C = '1')then
				en_M_C <= '0';
			end if;
		end if;
		if(cpld_str = '1')then
			sel_mod_dl <= sel_mod;
			if(CRC_VME(24) = '0')then
				CTRL_i(4) <= '0';
			elsif(calc_crc = '1')then
				CTRL_i(4) <= '1';
			elsif((sel_mod = '0' and sel_mod_dl = '1') or calc_crc_q = '1')then
				CTRL_i(4) <= '0';
			elsif(cpld_data(24) = '1')then
				CTRL_i(4) <= '1';
			end if;
			if(cpld_str = '1')then
				if(CRC_vme(24) = '0' and CTRL_i(4) = '0')then
					CRC_vme <= CRC_vme(23 downto 0) & M(2);
				end if;
			end if;
			if(CONF_busy = '0' or conf_cntr(cntr_msb) = '1')then
				CTRL_i(0) <= '1';
			elsif(conf_cntr(cntr_msb) = '0' and conf_cntr(cntr_msb-6) = '1' and conf_cntr(5 downto 3) = "101" and conf_cntr(1) = '1')then
				CTRL_i(0) <= '0';
			end if;
			if(CONF_busy = '0' or conf_cntr(cntr_msb) = '0')then
				CTRL_i(1) <= '1';
			elsif(rst_crc = '1')then
				CTRL_i(1) <= '0';
			end if;
			if(CTRL_i(2) = '1')then
				CONF_busy <= '1';
			elsif(conf_cntr(cntr_msb) = '1' and conf_cntr(cntr_msb-2) = '1')then
				CONF_busy <= '0';
			end if;
			CONF_busy_q <= CONF_busy;
		end if;
	end if;
end process;
reprog <= CTRL_i(2) and CRC_vme(24);
i_rst_reprog: delayN generic map(N => 16) port map(d => reprog, ce => cpld_str, c => clk0, q => rst_reprog);
process(clk0)
begin
	if(clk0'event and clk0 = '1')then
		cpld_str <= clkdv2 and not strobe;
		if(cpld_str = '1')then
			M_D <= (flash_MD and not CONF_busy) or FAST_READ;
			if(calc_crc = '1' or (sel_mod = '0' and sel_mod_dl = '1'))then
				cpld_data <= (others => '0');
			elsif(cpld_data(24) = '0')then
				cpld_data <= cpld_data(23 downto 0) & M(2);
			end if;
			if(rst_crc = '1')then
				CRC_LRB <= (others => '1');
			elsif(calc_crc = '1')then
				CRC_LRB(23) <= CRC_LRB(23) xor CRC_LRB(22);
				CRC_LRB(22 downto 19) <= CRC_LRB(21 downto 18);
				CRC_LRB(18) <= CRC_LRB(23) xor CRC_LRB(17);
				CRC_LRB(17) <= CRC_LRB(23) xor CRC_LRB(16);
				CRC_LRB(16 downto 15) <= CRC_LRB(15 downto 14);
				CRC_LRB(14) <= CRC_LRB(23) xor CRC_LRB(13);
				CRC_LRB(13 downto 12) <= CRC_LRB(12 downto 11);
				CRC_LRB(11) <= CRC_LRB(23) xor CRC_LRB(10);
				CRC_LRB(10) <= CRC_LRB(23) xor CRC_LRB(9);
				CRC_LRB(9 downto 8) <= CRC_LRB(8 downto 7);
				CRC_LRB(7) <= CRC_LRB(23) xor CRC_LRB(6);
				CRC_LRB(6) <= CRC_LRB(23) xor CRC_LRB(5);
				CRC_LRB(5) <= CRC_LRB(23) xor CRC_LRB(4);
				CRC_LRB(4) <= CRC_LRB(23) xor CRC_LRB(3);
				CRC_LRB(3) <= CRC_LRB(23) xor CRC_LRB(2);
				CRC_LRB(2) <= CRC_LRB(1);
				CRC_LRB(1) <= CRC_LRB(23) xor CRC_LRB(0);
				CRC_LRB(0) <= CRC_LRB(23) xor M_Q;
			end if;
			if(conf_cntr(cntr_msb-6) = '1')then
				FAST_READ <= rom_FAST_READ;
			else
				FAST_READ <= '0';
			end if;
			if(CTRL_i(2) = '1')then
				conf_cntr <= (others => '0');
			elsif(conf_cntr(cntr_msb) = '0' or conf_cntr(cntr_msb-2) = '0')then
				conf_cntr <= conf_cntr + 1;
			end if;
			if(conf_cntr(cntr_msb-1 downto 0) = (t_rst_crc(22 downto 29-cntr_msb) & t_rst_crc(5 downto 0)))then
				rst_crc <= '1';
			else
				rst_crc <= '0';
			end if;
			if(conf_cntr(cntr_msb downto 0) = t_crc_dcc(cntr_msb downto 0))then
				ld_CRC_DCC <= '1';
			else
				ld_CRC_DCC <= '0';
			end if;
			if(CTRL_i(2) = '1')then
				calc_crc <= '1';
			elsif(conf_cntr(cntr_msb downto 0) = t_crc_end(cntr_msb downto 0))then
				calc_crc <= '0';
			end if;
			calc_crc_q <= calc_crc;
			if(ld_CRC_DCC = '1')then
				CRC_DCC <= CRC_LRB;
			end if;
		end if;
		send_SN <= cpld_str and calc_crc_q and not calc_crc;
	end if;
end process;
i_rom_FAST_READ : ROM32X1
   generic map (
      INIT => X"000010d0") -- fast read at 0x80000
   port map (
      O => rom_FAST_READ,   -- ROM output
      A0 => conf_cntr(0), -- ROM address[0]
      A1 => conf_cntr(1), -- ROM address[1]
      A2 => conf_cntr(2), -- ROM address[2]
      A3 => conf_cntr(3), -- ROM address[3]
      A4 => conf_cntr(4)  -- ROM address[4]
   );
end Behavioral;

