----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:39:40 06/29/2006 
-- Design Name: 
-- Module Name:    flash - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
-- 
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use mylib.DCC_pack.all;
---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity flash is
    generic (swap_byte : boolean := false);
    Port ( clk : in  STD_LOGIC;
           vme_am : in  STD_LOGIC_VECTOR (5 downto 0);
           addr : in  STD_LOGIC_VECTOR (15 downto 0);
           we_byte : in  STD_LOGIC_VECTOR (3 downto 0);
           w_data : in  STD_LOGIC_VECTOR (31 downto 0);
           flash_wdata : out  STD_LOGIC_VECTOR (31 downto 0);
           flash_rdata : out  STD_LOGIC_VECTOR (31 downto 0);
           flash_busy : out  STD_LOGIC;
           CPLD_str : in  STD_LOGIC;
           MQ : in  STD_LOGIC;
           MD : out  STD_LOGIC;
           MCS : out  STD_LOGIC_VECTOR (1 downto 0)
			  );
end flash;

architecture Behavioral of flash is
signal dia : std_logic_vector(0 downto 0) := (others => '0');
signal doa : std_logic_vector(31 downto 0) := (others => '0');
signal addra : std_logic_vector(13 downto 0) := (others => '0');
signal addrap : std_logic_vector(13 downto 0) := (others => '0');
signal w_addra : std_logic_vector(13 downto 0) := (others => '0');
signal w_addrb : std_logic_vector(13 downto 0) := (others => '0');
signal r_addra : std_logic_vector(13 downto 0) := (others => '0');
signal r_addrb : std_logic_vector(8 downto 0) := (others => '0');
signal byte_cnt : std_logic_vector(8 downto 0) := (others => '0');
signal en_FLASHp : std_logic := '0';
signal en_FLASH : std_logic := '0';
signal we_last_byte : std_logic := '0';
signal en_FLASH_dl : std_logic_vector(1 downto 0) := "00";
signal en_FLASH_q : std_logic_vector(2 downto 0) := "000";
signal cmd : std_logic := '0';
signal rd : std_logic := '0';
signal wea : std_logic := '0';
signal web : std_logic_vector(3 downto 0) := x"0";
attribute INIT : string;
attribute INIT of en_flash : signal is "0";
begin
we_last_byte <= we_byte(3) when swap_byte = false else we_byte(0);
MCS <= en_FLASH_dl;
process(clk)
begin
  if(clk'event and clk = '1')then
    if(cpld_str = '1')then
			if(en_FLASHp = '1')then
				en_FLASH <= '1';
			elsif(addra(11 downto 3) = byte_cnt and addra(2 downto 0) = "111")then
				en_FLASH <= '0';
			end if;
			if(en_FLASH = '0')then
				addra <= (others => '0');
				cmd <= '1';
			else
				addra(11 downto 0) <= addra(11 downto 0) + 1;
				if(addra(4 downto 0) = "11111")then
					cmd <= '0';
				end if;
			end if;
			wea <= en_FLASH_q(2) and en_FLASH_dl(1);
			en_FLASH_dl <= en_FLASH_dl(0) & en_FLASH;
			MD <= doa(0);
			if(en_FLASH_dl(1) = '0')then
				addrap <= (others => '0');
			elsif(wea = '1')then
				addrap(11 downto 0) <= addrap(11 downto 0) + 1;
			end if;
		end if;
		flash_busy <= en_flash or en_flash_dl(1);
		if(vme_am(5) = '1' and addr(9 downto 0) = F_wbuf_addr(11 downto 2) and we_byte(0) = '1')then
			if(w_data(31 downto 24) = x"0b")then -- changed to fast write 10/27/2008
				rd <= '1';
			else
				rd <= '0';
			end if;
		end if;
-- FLASH signals
		if(vme_am(5) = '1' and addr(9 downto 0) = F_cmd_addr(11 downto 2))then
			if(we_byte(2) = '1')then
				byte_cnt(8) <= w_data(8);
			end if;
			if(we_byte(3) = '1')then
				byte_cnt(7 downto 0) <= w_data(7 downto 0);
			end if;
		end if;
		if(we_last_byte = '1' and vme_am(5) = '1' and addr(9 downto 0) = F_cmd_addr(11 downto 2))then
			en_FLASHp <= '1';
		elsif(en_FLASH = '1')then
			en_FLASHp <= '0';
		end if;
  end if;
end process;
i_wbuf: ramb16bwe
   generic map (
      DATA_WIDTH_A => 1, -- Valid values are 1, 2, 3, 4, 8, 18, or 36
      DATA_WIDTH_B => 36) -- Valid values are 1, 2, 3, 4, 8, 18, or 36
     port map(
         dia => x"00000000", 
         dipa => x"0", 
         addra => w_addra,
         clka => clk, 
         ssra => '0', 
         ena => cpld_str, 
         wea => x"0",
         dib => w_data,
         dipb => x"0",
         addrb => w_addrb,
         clkb => clk,
         ssrb => '0',
         enb => '1',
         web => web,
				 dob => flash_wdata,
				 doa => doa);
web <= we_byte when vme_am(5) = '1' and addr(9 downto 7) = F_wbuf_addr(11 downto 9) else x"0";
w_addrb <= "00" & addr(6 downto 0) & "00000";
w_addra(13 downto 5) <= addra(13 downto 5);
w_addra(4 downto 0) <= not addra(4 downto 3) & addra(2 downto 0) when cmd = '0' else not addra(4 downto 0);
i_rbuf: ramb16_s1_s36
     port map(
         dia => dia, 
         addra => r_addra,
         clka => clk, 
         ssra => '0', 
         ena => cpld_str, 
         wea => wea,
         dib => x"00000000",
         dipb => x"0",
         addrb => r_addrb,
         clkb => clk,
         ssrb => '0',
         enb => '1',
         web => '0',
         dob => flash_rdata);
dia(0) <= MQ;
r_addra(13 downto 5) <= addrap(13 downto 5);
r_addra(4 downto 0) <= not addrap(4 downto 3) & addrap(2 downto 0) when rd = '1' else not addrap(4 downto 0);
r_addrb <= "00" & addr(6 downto 0);
-- need to add 8 more delays for fast read 10/27/2008
i_SRL16a : SRL16E
   port map (
      Q => en_FLASH_q(0),
      A0 => '1',
      A1 => '1',
      A2 => rd,
      A3 => rd,
			CE => cpld_str,
      CLK => CLK,
      D => en_FLASH_dl(0)
   );
i_SRL16b : SRL16E
   port map (
      Q => en_FLASH_q(1),
      A0 => '1',
      A1 => '1',
      A2 => rd,
      A3 => rd,
			CE => cpld_str,
      CLK => CLK,
      D => en_FLASH_q(0)
   );
i_SRL16c : SRL16E
   port map (
      Q => en_FLASH_q(2),
      A0 => '0',
      A1 => '0',
      A2 => '0',
      A3 => rd,
			CE => cpld_str,
      CLK => CLK,
      D => en_FLASH_q(1)
   );
end Behavioral;

